rolehandler/urls.py
#
#   Copyright 2018 CNIT - Consorzio Nazionale Interuniversitario per le Telecomunicazioni
#
#   Licensed under the Apache License, Version 2.0 (the "License");
#   you may not use this file except in compliance with the License.
#   You may obtain a copy of the License at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
#   Unless required by applicable law or agreed to in writing, software
#   distributed under the License is distributed on an  BASIS,
#   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#   See the License for the specific language governing permissions and
#   limitations under the License.
#

from django.conf.urls import url
from rolehandler import views

urlpatterns = [
    url(r'^list$', views.role_list, name='list'),
    url(r'^create$', views.create, name='create'),
    url(r'^(?P<role_id>[-\w]+)/delete$', views.delete, name='delete'),
    url(r'^(?P<role_id>[-\w]+)/update$', views.update, name='update'),
    url(r'^(?P<role_id>[-\w]+)$', views.get, name='get')

]

sf_t3d/urls.py
#
#   Copyright 2018 EveryUP Srl
#
#   Licensed under the Apache License, Version 2.0 (the "License");
#   you may not use this file except in compliance with the License.
#   You may obtain a copy of the License at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
#   Unless required by applicable law or agreed to in writing, software
#   distributed under the License is distributed on an  BASIS,
#   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#   See the License for the specific language governing permissions and
#   limitations under the License.
#

from django.conf.urls import url, include
from authosm import views as user_views
from sf_t3d import views

app_name = 'base'
urlpatterns = [
    url(r'^$', views.home, name='home'),
    url(r'^home', views.home, name='home'),
    url(r'^auth/$', user_views.user_login, name='auth_user'),
    url(r'^projects/', include('projecthandler.urls.project', namespace='projects'), name='projects_base'),
    url(r'^sdn/', include('sdnctrlhandler.urls', namespace='sdns'), name='sdns_base'),
    url(r'^vims/', include('vimhandler.urls', namespace='vims'), name='vims_base'),
    url(r'^k8scluster/', include('k8sclusterhandler.urls', namespace='k8sc'), name='k8sc_base'),
    url(r'^k8srepo/', include('k8srepohandler.urls', namespace='k8sr'), name='k8sr_base'),
    url(r'^osmrepo/', include('osmrepohandler.urls', namespace='osmr'), name='osmr_base'),
    url(r'^wims/', include('wimhandler.urls', namespace='wims'), name='wims_base'),
    url(r'^packages/', include('packagehandler.urls', namespace='packages'), name='packages_base'),
    url(r'^instances/', include('instancehandler.urls', namespace='instances'), name='instances_base'),
    url(r'^netslices/', include('netslicehandler.urls', namespace='netslices'), name='netslices_base'),
    url(r'^admin/users/', include('userhandler.urls', namespace='users'), name='users_base'),
    url(r'^admin/roles/', include('rolehandler.urls', namespace='roles'), name='roles_base'),
    url(r'^forbidden', views.forbidden, name='forbidden'),

]

rolehandler/models.py
# -*- coding: utf-8 -*-
from __future__ import unicode_literals

from django.db import models

# Create your models here.

rolehandler/views.py
#
#   Copyright 2019 EveryUP Srl
#
#   Licensed under the Apache License, Version 2.0 (the "License");
#   you may not use this file except in compliance with the License.
#   You may obtain a copy of the License at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
#   Unless required by applicable law or agreed to in writing, software
#   distributed under the License is distributed on an  BASIS,
#   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#   See the License for the specific language governing permissions and
#   limitations under the License.
#

from django.shortcuts import render, redirect
from sf_t3d.decorators import login_required
from django.http import HttpResponse
import yaml
import json
import logging
import authosm.utils as osmutils
from lib.osm.osmclient.clientv2 import Client

logging.basicConfig(level=logging.DEBUG)
log = logging.getLogger(__name__)


@login_required
def role_list(request):
    user = osmutils.get_user(request)
    client = Client()
    result = client.role_list(user.get_token())
    result = {
        'roles': result['data'] if result and result['error'] is False else []
    }
    return __response_handler(request, result, 'role_list.html')


@login_required
def create(request):
    user = osmutils.get_user(request)
    client = Client()
    role_data = {
       'name': request.POST['name'],
    }
    try:
        if 'permissions' in request.POST and request.POST.get('permissions') != '':
            role_permissions = yaml.load(request.POST.get('permissions'))

            if not isinstance(role_permissions, dict):
                raise ValueError('Role permissions should be provided in a key-value fashion')
            for key, value in role_permissions.items():
                if not isinstance(value, bool):
                    raise ValueError("Value of '{}' in a role permissionss should be boolean".format(key))
                role_data[key] = value
    except Exception as e:
        return __response_handler(request, {'status': 400, 'code': 'BAD_REQUEST', 'detail': e.message}, url=None, status=400)
    result = client.role_create(user.get_token(), role_data)
    if result['error']:
        return __response_handler(request, result['data'], url=None,
                                  status=result['data']['status'] if 'status' in result['data'] else 500)
    else:
        return __response_handler(request, {}, url=None, status=200)


@login_required
def delete(request, role_id=None):
    user = osmutils.get_user(request)
    try:
        client = Client()
        result = client.role_delete(user.get_token(), role_id)
    except Exception as e:
        log.exception(e)
        result = {'error': True, 'data': str(e)}
    if result['error']:
        return __response_handler(request, result['data'], url=None,
                                  status=result['data']['status'] if 'status' in result['data'] else 500)
    else:
        return __response_handler(request, {}, url=None, status=200)


@login_required
def update(request, role_id=None):
    user = osmutils.get_user(request)
    client = Client()
    payload = {
        'name': request.POST['name'],
        'permissions': {}
    }
    try:
        if 'permissions' in request.POST and request.POST.get('permissions') != '':
            role_permissions = yaml.load(request.POST.get('permissions'))

            if not isinstance(role_permissions, dict):
                    raise ValueError('Role permissions should be provided in a key-value fashion')
            for key, value in role_permissions.items():
                if not isinstance(value, bool):
                    raise ValueError('Value in a role permissions should be boolean')
                payload['permissions'][key] = value
    except Exception as e:
        return __response_handler(request, {'status': 400, 'code': 'BAD_REQUEST', 'detail': e.message}, url=None, status=400)
    result = client.role_update(user.get_token(), role_id, payload)
    if result['error']:
        return __response_handler(request, result['data'], url=None,
                                  status=result['data']['status'] if 'status' in result['data'] else 500)
    else:
        return __response_handler(request, {}, url=None, status=200)


@login_required
def get(request, role_id=None):
    user = osmutils.get_user(request)
    try:
        client = Client()
        get_res = client.role_get(user.get_token(), role_id)
    except Exception as e:
        log.exception(e)
        get_res = {'error': True, 'data': str(e)}
    if get_res['error']:
        return __response_handler(request, get_res['data'], url=None,
                                  status=get_res['data']['status'] if 'status' in get_res['data'] else 500)
    else:
        role = get_res['data']
        result = {
            '_id': role['_id'],
            'name': role['name'],
            'permissions': {key: value for key, value in role['permissions'].items() if key not in ['_id', 'name', 'root', '_admin'] }
        }
        return __response_handler(request, result, url=None, status=200)


def __response_handler(request, data_res, url=None, to_redirect=None, *args, **kwargs):
    raw_content_types = request.META.get('HTTP_ACCEPT', '*/*').split(',')
    if 'application/json' in raw_content_types or url is None:
        return HttpResponse(json.dumps(data_res), content_type="application/json", *args, **kwargs)
    elif to_redirect:
        return redirect(url, *args, **kwargs)
    else:
        return render(request, url, data_res)

rolehandler/templates/modal/role_create.html
<!--
Copyright 2019 EveryUP srl

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an  BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
-->
<div class="modal" id="modal_new_role" xmlns="http://www.w3.org/1999/html">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">×</span></button>
                <h4 class="modal-title">New Role</h4>
            </div>
            <form id="formCreateRole" action='{% url "roles:create"   %}'
                  class="form-horizontal"
                  method="post" enctype="multipart/form-data">
                {% csrf_token %}
                <div class="modal-body" id="modal_new_role_body">
                    <div class="form-group">
                        <label for="rolename" class="col-sm-3 control-label">Name *</label>
                        <div class="col-sm-6">
                            <input class="form-control" id="rolename" name="name"
                                   placeholder="Name" required>
                        </div>
                       
                    </div>
                   
                    <div class="form-group">
                        <label for="permissions" class="col-sm-3 control-label">Permissions </label>
                        <div class="col-sm-6">
                            <textarea class="form-control" id="permissions" name="permissions" placeholder="Yaml permissions"
                                      rows="10"></textarea>
                        </div>
                    </div>

                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-default pull-left" data-dismiss="modal">Cancel</button>
                    <button class="btn btn-primary"
                            data-loading-text="<i class='fa fa-circle-o-notch fa-spin'></i> Creating..."
                            id="create_new_role">Create
                    </button>

                </div>
            </form>
        </div>
        <!-- /.modal-content -->
    </div>
    <!-- /.modal-dialog -->
</div>

rolehandler/templates/modal/role_edit.html
<!--
Copyright 2019 EveryUP srl

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an  BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
-->
<div class="modal" id="modal_edit_role" xmlns="http://www.w3.org/1999/html">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">×</span></button>
                <h4 class="modal-title">Edit Role</h4>
            </div>
            <form id="formEditRole" action=""
                  class="form-horizontal"
                  method="post" enctype="multipart/form-data">
                {% csrf_token %}
                <input type="hidden"  id="projects_old" name="projects_old" value="asdasd">
                <div class="modal-body" id="modal_edit_role_body">
                    
                    <div class="form-group">
                        <label for="rolename" class="col-sm-3 control-label">Name *</label>
                        <div class="col-sm-6">
                            <input class="form-control" type="text" id="edit_rolename" name="name"
                                       placeholder="Name" required>
                        </div>
                        
                    </div>
                        
                    <div class="form-group">
                        <label for="permissions" class="col-sm-3 control-label">Permissions </label>
                        <div class="col-sm-6">
                            <textarea class="form-control" id="edit_permissions" name="permissions" placeholder="Yaml permissions"
                                      rows="10"></textarea>
                        </div>
                    </div>
                   
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-default pull-left" data-dismiss="modal">Cancel</button>
                    <button class="btn btn-primary"
                            data-loading-text="<i class='fa fa-circle-o-notch fa-spin'></i> Editing..."
                            id="create_edit_role">Apply
                    </button>

                </div>
            </form>
        </div>
        <!-- /.modal-content -->
    </div>
    <!-- /.modal-dialog -->
</div>